import javax.swing.JPanel;
import javax.swing.JComponent;
import java.awt.Dimension;
import java.awt.Point;
import java.awt.event.*;
import java.util.Vector;
import java.awt.Graphics;
import java.awt.event.*;
import javax.swing.BorderFactory;

public class DCardComponent extends JPanel implements AbstractComponent{

    int DEPTH = 30;
    // Vector to store the elements on this card.
    Vector elementVector = new Vector();
    // Text area for card name
    javax.swing.JTextField cardName = new javax.swing.JTextField();

    public boolean selected = false;
    public boolean exists = false;
    int xtemp, ytemp;
    // Constructor
    public DCardComponent(){
	exists = true;
	super.setSize(new java.awt.Dimension(150, 100));
        super.setCursor(java.awt.Cursor.getPredefinedCursor(java.awt.Cursor.DEFAULT_CURSOR));
        super.setVisible(true);
        super.setLayout(null);
        super.setToolTipText("Card information.");
        //super.setBackground(new java.awt.Color(255, 153, 0));
	super.setBackground(java.awt.Color.lightGray);
	super.setBorder(BorderFactory.createLineBorder(java.awt.Color.lightGray));
	//super.setBorder(BorderFactory.createRaisedBevelBorder());

	// event handling for the card component
	super.addMouseListener(new java.awt.event.MouseAdapter() {
		public void mouseClicked(java.awt.event.MouseEvent e) {
		    cardComponentMouseClicked(e);
		}
		public void mousePressed(java.awt.event.MouseEvent e) {
		    cardComponentMousePressed(e);
		}
		public void mouseDragged(java.awt.event.MouseEvent e) {
		    cardComponentMouseDragged(e);
		}
		public void mouseReleased(java.awt.event.MouseEvent e) {
		    cardComponentMouseReleased(e);
		}
	    });


        cardName.setToolTipText("Card name");
        cardName.setVisible(true);
        cardName.setSize(new java.awt.Dimension(70, 20));
        cardName.setSelectedTextColor(java.awt.SystemColor.textHighlight);
        cardName.setColumns(80);
        cardName.setBackground(java.awt.Color.lightGray);
        cardName.setLocation(new java.awt.Point(getWidth()/2 - 35, 5));

	super.add(cardName);


    }

    public void add(AbstractComponent a){
	Dimension d = ((AbstractComponent) a).getSize();
        if (selected == true){
	    if (a instanceof DCardComponent && d.getWidth() >= this.getWidth()){
		super.setSize(10 + (new Double(d.getWidth())).intValue(),this.getHeight());
	    }
	    a.setLocation(new Point((this.getWidth() - (new Double(d.getWidth())).intValue())/2 + 2, DEPTH));
	    DEPTH = DEPTH + 15 + (new Double(d.getHeight())).intValue();
	    if (this.getHeight() < DEPTH) {
		super.setSize(new Dimension(this.getWidth(),DEPTH + 10));
	    }
	    if (a instanceof DCardComponent){
		elementVector.add((DCardComponent) a);
		super.add((DCardComponent) a);
	    } else {
		elementVector.add((DElementComponent) a);
		super.add((DElementComponent) a);
	    }
	    repaint();
	}
	for (int i = 0; i < elementVector.size();i++){
	    if (a instanceof DCardComponent){
		((AbstractComponent) elementVector.get(i)).add(new DCardComponent());
	    } else if(a instanceof DElementComponent) {
		((AbstractComponent) elementVector.get(i)).add(new DElementComponent());
	    }
	}
	rearrange();
	repaint();
    }


    public void moved(AbstractComponent card){
        // this method is to rearrange cards after one has been moved
        //System.out.println("Index of moved element = " + elementVector.indexOf(card));
        int i = elementVector.indexOf(card);
        Dimension d = ((AbstractComponent) elementVector.get(i)).getSize();
        int maxwidth = (new Double(this.getSize().getWidth())).intValue();
        int maxheight = (new Double(this.getSize().getHeight())).intValue();	
        int width = (new Double(d.getWidth())).intValue();
        int height = (new Double(d.getHeight())).intValue();
        if (width + ((JComponent) elementVector.get(i)).getX() > maxwidth) {
            ((AbstractComponent) elementVector.get(i)).setLocation(new Point(maxwidth - width,((JComponent) elementVector.get(i)).getY() ));
        } else if (((JComponent) elementVector.get(i)).getX() < 0) {
            ((AbstractComponent) elementVector.get(i)).setLocation(new Point(0, ((JComponent) elementVector.get(i)).getY()));
        }
	if (height + ((JComponent) elementVector.get(i)).getY() > maxheight) {
	    ((AbstractComponent) elementVector.get(i)).setLocation(new Point(((JComponent) elementVector.get(i)).getX(), maxheight - height));
	} else if (((JComponent) elementVector.get(i)).getY() < 0) {
	    ((AbstractComponent) elementVector.get(i)).setLocation(new Point(((JComponent) elementVector.get(i)).getX(),5));
	}

        elementVector.insertElementAt(elementVector.remove(elementVector.indexOf(card)),0);

        // Now we need to redraw the cardVector
        super.removeAll();
	super.add(cardName);
        for (int j = 0; j < elementVector.size(); j++){
            super.add((JComponent) elementVector.get(j));
        }
	super.repaint();
    }



    public void rearrange(){
	// we need to find maximum width required and height required.
	Dimension d;
	int maxwidth = 0;
	DEPTH = 30;
	for (int i = 0;i < elementVector.size(); i++){
	    ((AbstractComponent) elementVector.get(i)).rearrange();
	    d = ((AbstractComponent) elementVector.get(i)).getSize();
	    if ((new Double(d.getWidth())).intValue() > maxwidth) maxwidth = (new Double(d.getWidth())).intValue() + 10;
	    ((AbstractComponent) elementVector.get(i)).setLocation(new Point((this.getWidth() - (new Double(d.getWidth())).intValue())/2 + 3, DEPTH));
	    DEPTH = DEPTH + 15 + (new Double(d.getHeight())).intValue();
	    if (this.getHeight() < DEPTH) {
		super.setSize(new Dimension(this.getWidth(),DEPTH + 10));
	    }

	}

	if (DEPTH + 20 < this.getHeight() && DEPTH > 100) {
	    super.setSize(new Dimension(this.getWidth(),DEPTH + 10));
	} else if (DEPTH < 100) {
	    super.setSize(new Dimension(this.getWidth(), 100));
	}

	if (maxwidth >= this.getWidth()){
	    super.setSize(10 + maxwidth,this.getHeight());
	} else if(maxwidth < 150) super.setSize(150,this.getHeight());
    }

    public void setName(String s){
	cardName.setText(s);
    }

    public void setLocation(Point p){
	super.setLocation(p);
    }

    public void setSize(Dimension d){
	super.setSize(d);
    }

    public Dimension getSize(){
	return super.getSize();
    }

    public void toggleSelect(){
	if (selected){
	    //super.setBackground(new java.awt.Color(255, 153, 0));
	    super.setBorder(BorderFactory.createLineBorder(java.awt.Color.lightGray));
	    selected = false;
	    repaint();
	} else {
	    //super.setBackground(java.awt.Color.magenta);
	    super.setBorder(BorderFactory.createLineBorder(java.awt.Color.red));
	    selected = true;
	    repaint();
	}
    }

    public void paintComponent(Graphics g){
	int h = getHeight();
	int w = getWidth();
	int[] bxpoints = {0,20,20};
	int[] bypoints = {20,20,0};
	int[] oxpoints = {0,0,20};
	int[] oypoints = {0,20,0};            
	int[] blxpoints = {0,0,30,30}; int[] blypoints = {h-30,h,h,h-30};
	int[] brxpoints = {w-30,w-30,w,w}; int[] brypoints = {h-30,h,h,h-30};
	int[] trxpoints = {w-30,w-30,w,w}; int[] trypoints = {0,30,30,0};
	super.paintComponent(g);	


	//if (selected == true) {
	    g.setColor(java.awt.Color.black);
	    g.fillPolygon(bxpoints,bypoints,3);
	    // drawing black border.
	    g.drawLine(2,20,2,h-2);
	    g.drawLine(2,h-2,w-2,h-2);
	    g.drawLine(20,2,w-2,2);
	    g.drawLine(w-2,2,w-2,h-2);

	    // The following stuff can be used for curved borders.
	    /*g.setColor(new java.awt.Color(255,100,0));
	    g.fillPolygon(oxpoints,oypoints,3);
	    g.fillPolygon(blxpoints,blypoints,4);
	    g.fillPolygon(brxpoints,brypoints,4);
	    g.fillPolygon(trxpoints,trypoints,4);
	    g.setColor(java.awt.Color.magenta);
	    g.fillArc(w - 60, 0, 60, 60, 0, 90);
	    g.fillArc(0,h - 60, 60, 60, 180, 90);
	    g.fillArc(w - 60, h - 60, 60, 60, 270, 90);
	} else {
	    g.fillPolygon(bxpoints,bypoints,3);
	    g.setColor(new java.awt.Color(255,100,0));
	    g.fillPolygon(oxpoints,oypoints,3);
	    g.fillPolygon(blxpoints,blypoints,4);
	    g.fillPolygon(brxpoints,brypoints,4);
	    g.fillPolygon(trxpoints,trypoints,4);
	    g.setColor(new java.awt.Color(255,153,0));
	    g.fillArc(w - 60, 0, 60, 60, 0, 90);
	    g.fillArc(0,h - 60, 60, 60, 180, 90);
	    g.fillArc(w - 60, h - 60, 60, 60, 270, 90);
	    }*/

    }


    public String genQuery() {
	String name, subquery;
	name = cardName.getText();
	subquery = this.getSubQueries();
	return("<" + name + "> \n " + subquery + "\n</" + name + ">");
    }

    public String getSubQueries(){
	String subQ = "";
	int i;
	for(i=0;i< elementVector.size() - 1; i++){
	    subQ += ((AbstractComponent) elementVector.get(i)).genQuery() + "\n";
	}
	if (elementVector.size() > 0)
	subQ += ((AbstractComponent) elementVector.get(i)).genQuery();
	return subQ;
    }

    // updateClick makes sure this Object does not get deleted unless specifically selected
    public void updateClick(){
	selected = false;
    }

    public void cardComponentMousePressed(MouseEvent e) {
	e.consume();
	//System.out.println("Mouse pressed on: " + e.getPoint());
	xtemp = e.getX();
	ytemp = e.getY();
	//super.setLocation(e.getPoint());
    }
    
    public void cardComponentMouseReleased(MouseEvent e) {
	e.consume();
	//System.out.println("Mouse released on: " + e.getPoint());
	super.setLocation(super.getX() + e.getX() - xtemp, super.getY() + e.getY() - ytemp);
	xtemp = 0;
	ytemp = 0;
	((AbstractComponent) getParent()).moved(this);
    }
    
    public void cardComponentMouseDragged(MouseEvent e) {
	e.consume();
	//System.out.println("Mouse dragged : " + e.getX() + " " + e.getY());	
	super.setLocation(e.getPoint());
    }


    public void cardComponentMouseClicked(MouseEvent e){    
	System.out.println("Card clicked: " + cardName.getText());
	if (selected){
	    //super.setBackground(new java.awt.Color(255, 153, 0));
	    super.setBorder(BorderFactory.createLineBorder(java.awt.Color.lightGray));
	    selected = false;
	    repaint();
	} else {
	    //super.setBackground(java.awt.Color.magenta);
	    super.setBorder(BorderFactory.createLineBorder(java.awt.Color.red));
	    selected = true;
	    repaint();
	}
    }

    public boolean isSelected(){
	return selected;
    }

    public void erase(){
	for(int i = 0 ; i < elementVector.size(); i++){
	    if (((AbstractComponent) elementVector.get(i)).isSelected()){
		if(elementVector.get(i) instanceof DCardComponent) {
		    super.remove((DCardComponent)elementVector.get(i));
		} else if (elementVector.get(i) instanceof DElementComponent) {
		    super.remove((DElementComponent)elementVector.get(i));
		}
		elementVector.removeElementAt(i);
	    } else {
		((AbstractComponent) elementVector.get(i)).erase();
	    }
	}
	//this.rearrange();
    }

}
	
