/** 
 * FoXQFrame.java
 *
 * Title: The FoXQ Interface
 * Description:	This is the modified interface for FoXQ.
 * @author Robin Abraham
 * @version 1.0			
 */


import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.Vector;
import java.io.IOException;
import java.net.MalformedURLException;

public class FoXQFrame extends javax.swing.JFrame {

        // mode decides what action is possible next.
        String mode = "";
        String url = "";
        // component stores the current basic query component -> rule or folder
        AbstractComponent component;
        DisplayFrame display;
	// member declarations
	javax.swing.JPanel optionsPanel = new javax.swing.JPanel();
	javax.swing.JButton helpButton = new javax.swing.JButton();
	javax.swing.JButton urlButton = new javax.swing.JButton();
	javax.swing.JButton cardButton = new javax.swing.JButton();
	javax.swing.JButton elementButton = new javax.swing.JButton();
	javax.swing.JButton ruleButton = new javax.swing.JButton();
	javax.swing.JButton runButton = new javax.swing.JButton();
	javax.swing.JButton openButton = new javax.swing.JButton();
	javax.swing.JButton saveButton = new javax.swing.JButton();
	javax.swing.JButton eraseButton = new javax.swing.JButton();
	javax.swing.JScrollPane DTDViewerPane = new javax.swing.JScrollPane();
	javax.swing.JPanel DTDViewer = new javax.swing.JPanel();
	javax.swing.JPanel extrasPanel = new javax.swing.JPanel();
	javax.swing.JScrollPane queryScrollPane = new javax.swing.JScrollPane();
	javax.swing.JPanel queryPanel = new javax.swing.JPanel();
    
	public FoXQFrame() {
	}

	public void initComponents() throws Exception {
		// the following code picks the button icons
		java.awt.Image img0 = getToolkit().getImage(ClassLoader.getSystemResource("images/helpNormal.gif"));
		java.awt.Image img1 = getToolkit().getImage(ClassLoader.getSystemResource("images/helpClicked.gif"));
		java.awt.Image img2 = getToolkit().getImage(ClassLoader.getSystemResource("images/urlNormal.gif"));
		java.awt.Image img3 = getToolkit().getImage(ClassLoader.getSystemResource("images/urlClicked.gif"));
		java.awt.Image img4 = getToolkit().getImage(ClassLoader.getSystemResource("images/cardNormal.gif"));
		java.awt.Image img5 = getToolkit().getImage(ClassLoader.getSystemResource("images/cardClicked.gif"));
		java.awt.Image img6 = getToolkit().getImage(ClassLoader.getSystemResource("images/elementNormal.gif"));
		java.awt.Image img7 = getToolkit().getImage(ClassLoader.getSystemResource("images/elementClicked.gif"));
		java.awt.Image img8 = getToolkit().getImage(ClassLoader.getSystemResource("images/ruleNormal.gif"));
		java.awt.Image img9 = getToolkit().getImage(ClassLoader.getSystemResource("images/ruleClicked.gif"));
		java.awt.Image img10 = getToolkit().getImage(ClassLoader.getSystemResource("images/runNormal.gif"));
		java.awt.Image img11 = getToolkit().getImage(ClassLoader.getSystemResource("images/runClicked.gif"));
		java.awt.Image img12 = getToolkit().getImage(ClassLoader.getSystemResource("images/openNormal.gif"));
		java.awt.Image img13 = getToolkit().getImage(ClassLoader.getSystemResource("images/openClicked.gif"));
		java.awt.Image img14 = getToolkit().getImage(ClassLoader.getSystemResource("images/saveNormal.gif"));
		java.awt.Image img15 = getToolkit().getImage(ClassLoader.getSystemResource("images/saveClicked.gif"));
		java.awt.Image img16 = getToolkit().getImage(ClassLoader.getSystemResource("images/eraseNormal.gif"));
		java.awt.Image img17 = getToolkit().getImage(ClassLoader.getSystemResource("images/eraseClicked.gif"));

		// Setup for the options panel (one on WEST)
		optionsPanel.setCursor(java.awt.Cursor.getPredefinedCursor(java.awt.Cursor.DEFAULT_CURSOR));
		optionsPanel.setSize(new java.awt.Dimension(100, 800));
		optionsPanel.setBorder(new javax.swing.border.SoftBevelBorder(0));
		optionsPanel.setLocation(new java.awt.Point(0, 0));
		optionsPanel.setVisible(true);
		optionsPanel.setLayout(null);
		optionsPanel.setToolTipText("Move your mouse over any item for descriptions.");
		optionsPanel.setBackground(new java.awt.Color(255, 153, 0));

		// Setup for buttons (on WEST)
		helpButton.setIcon(new javax.swing.ImageIcon(img0));
		helpButton.setPressedIcon(new javax.swing.ImageIcon(img1));
		helpButton.setToolTipText("Click for help");
		helpButton.setBorder(new javax.swing.plaf.BorderUIResource.EmptyBorderUIResource(new java.awt.Insets(0, 0, 0, 0)));
		helpButton.setVisible(true);
		helpButton.setSize(new java.awt.Dimension(70, 70));
		helpButton.setSelectedIcon(new javax.swing.ImageIcon(img1));
		helpButton.setBackground(new java.awt.Color(255, 153, 0));
		helpButton.setContentAreaFilled(false);
		helpButton.setLocation(new java.awt.Point(10, 30));
		urlButton.setIcon(new javax.swing.ImageIcon(img2));
		urlButton.setPressedIcon(new javax.swing.ImageIcon(img3));
		urlButton.setToolTipText("Click to select XML data source");
		urlButton.setBorder(new javax.swing.plaf.BorderUIResource.EmptyBorderUIResource(new java.awt.Insets(0, 0, 0, 0)));
		urlButton.setVisible(true);
		urlButton.setSize(new java.awt.Dimension(70, 80));
		urlButton.setSelectedIcon(new javax.swing.ImageIcon(img3));
		urlButton.setBackground(new java.awt.Color(255, 153, 0));
		urlButton.setContentAreaFilled(false);
		urlButton.setLocation(new java.awt.Point(10, 120));
		cardButton.setIcon(new javax.swing.ImageIcon(img4));
		cardButton.setPressedIcon(new javax.swing.ImageIcon(img5));
		cardButton.setToolTipText("Click to generate new card");
		cardButton.setBorder(new javax.swing.plaf.BorderUIResource.EmptyBorderUIResource(new java.awt.Insets(0, 0, 0, 0)));
		cardButton.setVisible(true);
		cardButton.setSize(new java.awt.Dimension(70, 70));
		cardButton.setSelectedIcon(new javax.swing.ImageIcon(img5));
		cardButton.setBackground(new java.awt.Color(255, 153, 0));
		cardButton.setContentAreaFilled(false);
		cardButton.setLocation(new java.awt.Point(10, 210));
		elementButton.setIcon(new javax.swing.ImageIcon(img6));
		elementButton.setPressedIcon(new javax.swing.ImageIcon(img7));
		elementButton.setToolTipText("Click to generate new element");
		elementButton.setBorder(new javax.swing.plaf.BorderUIResource.EmptyBorderUIResource(new java.awt.Insets(0, 0, 0, 0)));
		elementButton.setVisible(true);
		elementButton.setSize(new java.awt.Dimension(70, 70));
		elementButton.setSelectedIcon(new javax.swing.ImageIcon(img6));
		elementButton.setBackground(new java.awt.Color(255, 153, 0));
		elementButton.setContentAreaFilled(false);
		elementButton.setLocation(new java.awt.Point(10, 290));
		ruleButton.setIcon(new javax.swing.ImageIcon(img8));
		ruleButton.setPressedIcon(new javax.swing.ImageIcon(img9));
		ruleButton.setToolTipText("Click to generate rule");
		ruleButton.setBorder(new javax.swing.plaf.BorderUIResource.EmptyBorderUIResource(new java.awt.Insets(0, 0, 0, 0)));
		ruleButton.setVisible(true);
		ruleButton.setSize(new java.awt.Dimension(70, 70));
		ruleButton.setSelectedIcon(new javax.swing.ImageIcon(img9));
		ruleButton.setBackground(new java.awt.Color(255, 153, 0));
		ruleButton.setContentAreaFilled(false);
		ruleButton.setLocation(new java.awt.Point(10, 370));

		runButton.setIcon(new javax.swing.ImageIcon(img10));
		runButton.setPressedIcon(new javax.swing.ImageIcon(img11));
		runButton.setToolTipText("Click to run query");
		runButton.setBorder(new javax.swing.plaf.BorderUIResource.EmptyBorderUIResource(new java.awt.Insets(0, 0, 0, 0)));
		runButton.setVisible(true);
		runButton.setSize(new java.awt.Dimension(70, 70));
		runButton.setSelectedIcon(new javax.swing.ImageIcon(img11));
		runButton.setBackground(new java.awt.Color(255, 153, 0));
		runButton.setContentAreaFilled(false);
		runButton.setLocation(new java.awt.Point(10, 450));
		
		eraseButton.setIcon(new javax.swing.ImageIcon(img16));
		eraseButton.setPressedIcon(new javax.swing.ImageIcon(img17));
		eraseButton.setToolTipText("Select elements and click to erase");
		eraseButton.setBorder(new javax.swing.plaf.BorderUIResource.EmptyBorderUIResource(new java.awt.Insets(0, 0, 0, 0)));
		eraseButton.setVisible(true);
		eraseButton.setSize(new java.awt.Dimension(70, 70));
		eraseButton.setSelectedIcon(new javax.swing.ImageIcon(img17));
		eraseButton.setBackground(new java.awt.Color(255, 153, 0));
		eraseButton.setContentAreaFilled(false);
		eraseButton.setLocation(new java.awt.Point(10, 530));

		// File option buttons for SOUTH panel.
		openButton.setIcon(new javax.swing.ImageIcon(img12));
		openButton.setPressedIcon(new javax.swing.ImageIcon(img13));
		openButton.setToolTipText("Click to open file");
		openButton.setBorder(new javax.swing.plaf.BorderUIResource.EmptyBorderUIResource(new java.awt.Insets(0, 0, 0, 0)));
		openButton.setVisible(true);
		openButton.setSize(new java.awt.Dimension(70, 70));
		openButton.setSelectedIcon(new javax.swing.ImageIcon(img13));
		openButton.setBackground(new java.awt.Color(255, 153, 0));
		openButton.setContentAreaFilled(false);
		openButton.setLocation(new java.awt.Point(10, 10));
		saveButton.setIcon(new javax.swing.ImageIcon(img14));
		saveButton.setPressedIcon(new javax.swing.ImageIcon(img15));
		saveButton.setToolTipText("Click to save file");
		saveButton.setBorder(new javax.swing.plaf.BorderUIResource.EmptyBorderUIResource(new java.awt.Insets(0, 0, 0, 0)));
		saveButton.setVisible(true);
		saveButton.setSize(new java.awt.Dimension(70, 70));
		saveButton.setSelectedIcon(new javax.swing.ImageIcon(img15));
		saveButton.setBackground(new java.awt.Color(255, 153, 0));
		saveButton.setContentAreaFilled(false);
		saveButton.setLocation(new java.awt.Point(90, 10));

		// Setup for the DTD viewer (on EAST)
		DTDViewerPane.setCursor(java.awt.Cursor.getPredefinedCursor(java.awt.Cursor.DEFAULT_CURSOR));
		DTDViewerPane.setSize(new java.awt.Dimension(150, 800));
		DTDViewerPane.setLocation(new java.awt.Point(840, 0));
		DTDViewerPane.setDoubleBuffered(true);
		DTDViewerPane.setVisible(true);
		DTDViewerPane.setBackground(java.awt.Color.orange);
		DTDViewer.setBorder(new javax.swing.border.SoftBevelBorder(0));
		DTDViewer.setVisible(true);
		DTDViewer.setLayout(null);
		DTDViewer.setBackground(new java.awt.Color(255, 153, 0));

		// Setup for the extra-options panel (on SOUTH)
		extrasPanel.setCursor(java.awt.Cursor.getPredefinedCursor(java.awt.Cursor.DEFAULT_CURSOR));
		extrasPanel.setSize(new java.awt.Dimension(740, 100));
		extrasPanel.setBorder(new javax.swing.border.SoftBevelBorder(0));
		extrasPanel.setLocation(new java.awt.Point(100, 670));
		extrasPanel.setVisible(true);
		extrasPanel.setLayout(null);
		extrasPanel.setToolTipText("Extra menu options");
		extrasPanel.setBackground(new java.awt.Color(255, 153, 0));

		// Setup for query panel (on NORTH)
		queryScrollPane.setCursor(java.awt.Cursor.getPredefinedCursor(java.awt.Cursor.DEFAULT_CURSOR));
		queryScrollPane.setSize(new java.awt.Dimension(740, 670));
		queryScrollPane.setLocation(new java.awt.Point(100, 0));
		queryScrollPane.setVisible(true);
		queryScrollPane.setToolTipText("FoXQ query builder area");
		queryScrollPane.setBackground(new java.awt.Color(255, 153, 0));
		queryScrollPane.setVerticalScrollBarPolicy(javax.swing.ScrollPaneConstants.VERTICAL_SCROLLBAR_AS_NEEDED);
		queryScrollPane.setHorizontalScrollBarPolicy(javax.swing.ScrollPaneConstants.HORIZONTAL_SCROLLBAR_AS_NEEDED);
		queryPanel.setVisible(true);
		queryPanel.setLayout(null);
		queryPanel.setToolTipText("FoXQ query builder area");
		//queryPanel.setBackground(java.awt.Color.orange);
		queryPanel.setBackground(java.awt.Color.white);
		setCursor(java.awt.Cursor.getPredefinedCursor(java.awt.Cursor.CROSSHAIR_CURSOR));
		setLocation(new java.awt.Point(0, 0));
		getContentPane().setLayout(null);
		setTitle("FoXQ Interface");
		setResizable(false);
		getContentPane().setBackground(new java.awt.Color(255, 153, 0));

		optionsPanel.add(helpButton);
		optionsPanel.add(urlButton);
		optionsPanel.add(cardButton);
		optionsPanel.add(elementButton);
		optionsPanel.add(ruleButton);
		optionsPanel.add(runButton);
		optionsPanel.add(eraseButton);
		extrasPanel.add(saveButton);
		extrasPanel.add(openButton);
		DTDViewerPane.getViewport().add(DTDViewer);
		queryScrollPane.getViewport().add(queryPanel);
		getContentPane().add(optionsPanel);
		getContentPane().add(DTDViewerPane);
		getContentPane().add(extrasPanel);
		getContentPane().add(queryScrollPane);

		setSize(new java.awt.Dimension(1000, 800));

		// event handling for the options buttons
		helpButton.addMouseListener(new java.awt.event.MouseAdapter() {
			public void mouseClicked(java.awt.event.MouseEvent e) {
				helpButtonMouseClicked(e);
			}
		});

		urlButton.addMouseListener(new java.awt.event.MouseAdapter() {
			public void mouseClicked(java.awt.event.MouseEvent e) {
				urlButtonMouseClicked(e);
			}
		});

		cardButton.addMouseListener(new java.awt.event.MouseAdapter() {
			public void mouseClicked(java.awt.event.MouseEvent e) {
				cardButtonMouseClicked(e);
			}
		});

		elementButton.addMouseListener(new java.awt.event.MouseAdapter() {
			public void mouseClicked(java.awt.event.MouseEvent e) {
				elementButtonMouseClicked(e);
			}
		});

		ruleButton.addMouseListener(new java.awt.event.MouseAdapter() {
			public void mouseClicked(java.awt.event.MouseEvent e) {
				ruleButtonMouseClicked(e);
			}
		});

		runButton.addMouseListener(new java.awt.event.MouseAdapter() {
			public void mouseClicked(java.awt.event.MouseEvent e) {
				runButtonMouseClicked(e);
			}
		});
		eraseButton.addMouseListener(new java.awt.event.MouseAdapter() {
			public void mouseClicked(java.awt.event.MouseEvent e) {
				eraseButtonMouseClicked(e);
			}
		});
		// Event handling for the file option buttons

		openButton.addMouseListener(new java.awt.event.MouseAdapter() {
			public void mouseClicked(java.awt.event.MouseEvent e) {
				openButtonMouseClicked(e);
			}
		});

		saveButton.addMouseListener(new java.awt.event.MouseAdapter() {
			public void mouseClicked(java.awt.event.MouseEvent e) {
				saveButtonMouseClicked(e);
			}
		});

		addWindowListener(new java.awt.event.WindowAdapter() {
			public void windowClosing(java.awt.event.WindowEvent e) {
				thisWindowClosing(e);
			}
		});

		/*CardComponent c1 = new CardComponent(new Point(5,30));
		ElementComponent e1 = new ElementComponent(new Point(0,30));
		FolderComponent f1 = new FolderComponent(new Point(5,5));
		FolderComponent f2 = new FolderComponent(new Point(450,5));
		RuleComponent r1 = new RuleComponent();
		c1.add(e1);
		f1.add(c1);
		f2.add(c1);
		r1.add(f1);
		r1.add(f2);
		queryPanel.add(r1);*/
	}
  
  	private boolean mShown = false;
  	
	public void addNotify() {
	    super.addNotify();
		
	    if (mShown)
		return;
			
	    // resize frame to account for menubar
	    JMenuBar jMenuBar = getJMenuBar();
	    if (jMenuBar != null) {
		int jMenuBarHeight = jMenuBar.getPreferredSize().height;
		Dimension dimension = getSize();
		dimension.height += jMenuBarHeight;
		setSize(dimension);
		
		// move down components in layered pane
		Component[] components = getLayeredPane().getComponentsInLayer(JLayeredPane.DEFAULT_LAYER.intValue());
		for (int i = 0; i < components.length; i++) {
		    Point location = components[i].getLocation();
		    location.move(location.x, location.y + jMenuBarHeight);
		    components[i].setLocation(location);
		}
	    }
	    
	    mShown = true;
	}


        // Method to set the URL from the URLFrame
        public void setURL(String u){
	    url = "\""+ u +"\"";
	    // mode doesn't matter - this would start a new query anyway.
	    component = null;
	    component = new FolderComponent();
	    mode = "folder";
	    queryPanel.removeAll();
	    queryPanel.add((FolderComponent) component);
	    queryPanel.setPreferredSize(new java.awt.Dimension(queryPanel.getWidth(),668));
	    queryPanel.revalidate();
	    repaint();

	}

        // Button actions
	public void openButtonMouseClicked(java.awt.event.MouseEvent e) {
	    // mode doesn't matter.
	    try {
		ErrorDialog err = new ErrorDialog("File options not implemented in this version!");
		err.initComponents();
		err.setVisible(true);
	    }
	    catch (Exception ex) {
		ex.printStackTrace();
	    }

	}		
	public void saveButtonMouseClicked(java.awt.event.MouseEvent e) {
	    // mode doesn't matter.
	    try {
		ErrorDialog err = new ErrorDialog("File options not implemented in this version!");
		err.initComponents();
		err.setVisible(true);
	    }
	    catch (Exception ex) {
		ex.printStackTrace();
	    }
	}		

	public void helpButtonMouseClicked(java.awt.event.MouseEvent e) {
	    // mode doesn't matter.
	    try {
		ErrorDialog err = new ErrorDialog("Help not implemented in this version!");
		err.initComponents();
		err.setVisible(true);
	    }
	    catch (Exception ex) {
		ex.printStackTrace();
	    }
	}		

	public void eraseButtonMouseClicked(java.awt.event.MouseEvent e) {
	    if ((mode.equals("rule")||mode.equals("folder"))&&(component != null)){
		if (component.isSelected()){
		    component = null;
		    queryPanel.removeAll();
		    queryPanel.revalidate();
		    repaint();
		    System.gc();
		} else {
		    component.erase();
		    component.rearrange();
		    queryPanel.revalidate();
		    repaint();
		    System.gc();
		}
	    } else {
		try {
		    ErrorDialog err = new ErrorDialog("Screen empty - nothing to erase!");
		    err.initComponents();
		    err.setVisible(true);
		    mode = "";
		}
		catch (Exception ex) {
		    ex.printStackTrace();
		}
	    }
	}		

	public void urlButtonMouseClicked(java.awt.event.MouseEvent e) {
	    try {
	      	URLFrame frame = new URLFrame(this);
	       	frame.initComponents();
	       	frame.setVisible(true);
	    }
		catch (Exception ex) {
		   ex.printStackTrace();
	    }
      	}		

	public void cardButtonMouseClicked(java.awt.event.MouseEvent e) {
	    // this can only be done if mode is "rule" or "folder"
	    CardComponent tempCard = new CardComponent();
	    if (mode.equals("rule") || mode.equals("folder")){
		component.add(new CardComponent());
		if (((JComponent) component).getHeight() > queryPanel.getHeight()){
		    queryPanel.setSize(new java.awt.Dimension(queryPanel.getWidth(),((JComponent) component).getHeight()));
		    queryPanel.setPreferredSize(new java.awt.Dimension(queryPanel.getWidth(),((JComponent) component).getHeight()));
		}
	    } else {
		//System.out.println("Start making rule or folder first");
		try {
		ErrorDialog err = new ErrorDialog("Card can be added only to rule or folder - start making rule or folder!");
		err.initComponents();
		err.setVisible(true);
		}
		catch (Exception ex) {
		    ex.printStackTrace();
		}
	    }
	    //System.gc();
	    //if (((JComponent) component).getHeight() > queryPanel.getHeight()){
	    //queryPanel.setSize(new java.awt.Dimension(queryPanel.getWidth(),((JComponent) component).getHeight()));
	    //queryPanel.setPreferredSize(new java.awt.Dimension(queryPanel.getWidth(),((JComponent) component).getHeight()));
	    //}
	    queryPanel.revalidate();
	    queryPanel.repaint();
       	}		

	public void elementButtonMouseClicked(java.awt.event.MouseEvent e) {
	    if (mode.equals("rule") || mode.equals("folder")){
		//System.out.println("Going to add element");
		component.add(new ElementComponent());
		if (((JComponent) component).getHeight() > queryPanel.getHeight()){
		    queryPanel.setSize(new java.awt.Dimension(queryPanel.getWidth(),((JComponent) component).getHeight()));
		    queryPanel.setPreferredSize(new java.awt.Dimension(queryPanel.getWidth(),((JComponent) component).getHeight()));
		}
	    } else {
		//System.out.println("Start making rule or folder first");
		try {
		    ErrorDialog err = new ErrorDialog("Element can only be added to cards - start making rule or folder first!");
		    err.initComponents();
		    err.setVisible(true);
		}
		catch (Exception ex) {
		    ex.printStackTrace();
		}
	    }
	    //if (((JComponent) component).getHeight() > queryPanel.getHeight()){
	    //queryPanel.setSize(new java.awt.Dimension(queryPanel.getWidth(),((JComponent) component).getHeight()));
	    //queryPanel.setPreferredSize(new java.awt.Dimension(queryPanel.getWidth(),((JComponent) component).getHeight()));
	    //}
	    queryPanel.revalidate();
	    queryPanel.repaint();
       	}		

	public void ruleButtonMouseClicked(java.awt.event.MouseEvent e) {
	    if (mode.equals("folder")) {
		FolderComponent tempFolder = (FolderComponent) component; //new FolderComponent();
		component = null;
	      	component = new RuleComponent();
		((RuleComponent) component).add((AbstractComponent) tempFolder);
		queryPanel.removeAll();
	    } else {
		try {
		    URLFrame frame = new URLFrame(this);
		    frame.initComponents();
		    frame.setVisible(true);
		}
		catch (Exception ex) {
		    ex.printStackTrace();
		}
		System.out.println("After capturing url = " + url);
		FolderComponent tempFolder = (FolderComponent) component; //new FolderComponent();
		component = null;
		component = new RuleComponent();
		((RuleComponent) component).add((AbstractComponent) tempFolder);
		queryPanel.removeAll();
		//component = null;
		//component = new RuleComponent();
		//queryPanel.removeAll();
	    }
	    mode = "rule";
	    queryPanel.add((RuleComponent) component);
	    repaint();
	    queryPanel.revalidate();
       	}
		
	public void runButtonMouseClicked(java.awt.event.MouseEvent e) {
	    String query = "";
	    if (mode.equals("rule") || mode.equals("folder")){
		if(display != null){
		    //display = null;
		    display.setVisible(false);
		    display.dispose();
		}
		// starting progress bar
		//ProgressFrame frame = new ProgressFrame();
		try {
		    if (mode.equals("rule")){
			query = component.genQuery();
		    } else if (mode.equals("folder")){
			String temp = component.genQuery();
			query = "p="+temp+"&r="+temp;
		    }
		    query += "&url=" + url;
		    XingExec xexec = new XingExec(query);
		    //System.out.println("XinExec done!!");
		    FoXQReader reader = new FoXQReader(xexec.getStream());
		    //System.out.println("FoXQ Reader done!");
		    if (display == null ) {
			//System.out.println("Display object is not alive");
			display = new DisplayFrame();
		    }
		    display.clearScreen();
		    try {
			display.initComponents();
		    } catch (Exception ex){
			
		    }
		    display.setVisible(true);
		    display.displayXML((DFolderComponent) reader.returnComponent());
		} catch (MalformedURLException ex){
		    try {
			ErrorDialog err = new ErrorDialog("Malformed URL. Make corrections and try again!!");
			err.initComponents();
			err.setVisible(true);
		    }
		    catch (Exception em) {
			em.printStackTrace();
		    }
		} catch (IOException ex){ 
		    try {
			ErrorDialog err = new ErrorDialog("Data source cannot be accessed. Check and try again!!");
			err.initComponents();
			err.setVisible(true);
			ex.printStackTrace();
		    }
		    catch (Exception em) {
			em.printStackTrace();
		    }
		} catch (Exception ex) {
		    ex.printStackTrace();		    
		}
	    } else {
		try {
		    ErrorDialog err = new ErrorDialog("Start making rule or folder first!");
		    err.initComponents();
		    err.setVisible(true);
		}
		catch (Exception ex) {
		    ex.printStackTrace();
		}

	    }
	    
       	}

	// Close the window when the close box is clicked
	void thisWindowClosing(java.awt.event.WindowEvent e) {
		setVisible(false);
		dispose();
		System.exit(0);
	}
	
}
